
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SubjectsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subjects = await db.subjects.create(
            {
                id: data.id || undefined,
        
        name_om: data.name_om
        ||
        null
            ,
            
        name_am: data.name_am
        ||
        null
            ,
            
        name_en: data.name_en
        ||
        null
            ,
            
        overview_om: data.overview_om
        ||
        null
            ,
            
        overview_am: data.overview_am
        ||
        null
            ,
            
        overview_en: data.overview_en
        ||
        null
            ,
            
        textbook_references: data.textbook_references
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return subjects;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const subjectsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name_om: item.name_om
            ||
            null
            ,
            
                name_am: item.name_am
            ||
            null
            ,
            
                name_en: item.name_en
            ||
            null
            ,
            
                overview_om: item.overview_om
            ||
            null
            ,
            
                overview_am: item.overview_am
            ||
            null
            ,
            
                overview_en: item.overview_en
            ||
            null
            ,
            
                textbook_references: item.textbook_references
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const subjects = await db.subjects.bulkCreate(subjectsData, { transaction });

        // For each item created, replace relation files
        

        return subjects;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const subjects = await db.subjects.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name_om !== undefined) updatePayload.name_om = data.name_om;
        
        
        if (data.name_am !== undefined) updatePayload.name_am = data.name_am;
        
        
        if (data.name_en !== undefined) updatePayload.name_en = data.name_en;
        
        
        if (data.overview_om !== undefined) updatePayload.overview_om = data.overview_om;
        
        
        if (data.overview_am !== undefined) updatePayload.overview_am = data.overview_am;
        
        
        if (data.overview_en !== undefined) updatePayload.overview_en = data.overview_en;
        
        
        if (data.textbook_references !== undefined) updatePayload.textbook_references = data.textbook_references;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        updatePayload.updatedById = currentUser.id;

        await subjects.update(updatePayload, {transaction});

        
        

        
        

        

        return subjects;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subjects = await db.subjects.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of subjects) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of subjects) {
                await record.destroy({transaction});
            }
        });


        return subjects;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const subjects = await db.subjects.findByPk(id, options);

        await subjects.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await subjects.destroy({
            transaction
        });

        return subjects;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const subjects = await db.subjects.findOne(
            { where },
            { transaction },
        );

        if (!subjects) {
            return subjects;
        }

        const output = subjects.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.subject_offerings_subject = await subjects.getSubject_offerings_subject({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.study_materials_subject = await subjects.getStudy_materials_subject({
            transaction
        });
        
        
        
        output.exam_results_subject = await subjects.getExam_results_subject({
            transaction
        });
        
        
        output.attendance_sessions_subject = await subjects.getAttendance_sessions_subject({
            transaction
        });
        
        
        
        output.class_schedules_subject = await subjects.getClass_schedules_subject({
            transaction
        });
        
        
        output.assignments_subject = await subjects.getAssignments_subject({
            transaction
        });
        
        
        
        output.lesson_plans_subject = await subjects.getLesson_plans_subject({
            transaction
        });
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'name_om',
                        filter.name_om,
                    ),
                };
            }
            
            if (filter.name_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'name_am',
                        filter.name_am,
                    ),
                };
            }
            
            if (filter.name_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'name_en',
                        filter.name_en,
                    ),
                };
            }
            
            if (filter.overview_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'overview_om',
                        filter.overview_om,
                    ),
                };
            }
            
            if (filter.overview_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'overview_am',
                        filter.overview_am,
                    ),
                };
            }
            
            if (filter.overview_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'overview_en',
                        filter.overview_en,
                    ),
                };
            }
            
            if (filter.textbook_references) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'textbook_references',
                        filter.textbook_references,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.subjects.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'subjects',
                        'name_en',
                        query,
                    ),
                ],
            };
        }

        const records = await db.subjects.findAll({
            attributes: [ 'id', 'name_en' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name_en', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name_en,
        }));
    }

    
};

